package com.mycom.webapp.action.shopping;

import com.konakart.al.Constants;
import com.konakart.al.KKAppException;
import com.konakart.app.Basket;
import com.konakart.app.OrderStatusHistory;
import com.konakart.app.PaymentDetails;
import com.konakart.appif.*;
import com.opensymphony.webwork.ServletActionContext;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;


public class TestCheckoutAction extends BaseKKAction{

    protected static KKEngIf eng;

    protected static final int DEFAULT_LANGUAGE = -1;

    private static String DEFAULT_USERNAME = "root@localhost";

    private static String DEFAULT_PASSWORD = "password";

    protected static String sessionId;

    private static int PROD_WITH_OPTIONS_ID = 2;

    private static int PROD_ID = 5;

    private static int PENDING = 1;

    private static int PROCESSING = 2;

    public String checkout() throws Exception{
        try{
        Class engineClass = Class.forName("com.konakart.app.KKEng");
        eng = (KKEngIf) engineClass.newInstance();
        sessionId = eng.login(DEFAULT_USERNAME, DEFAULT_PASSWORD);
        ProductIf prod = eng.getProduct(sessionId, PROD_WITH_OPTIONS_ID, DEFAULT_LANGUAGE);

        if (prod.getOpts() != null && prod.getOpts().length >= 3)
        {
            BasketIf item = new Basket();
            OptionIf[] opts = new OptionIf[2];
            opts[0] = prod.getOpts()[0];
            opts[1] = prod.getOpts()[2];

            item.setProductId(PROD_WITH_OPTIONS_ID);
            item.setQuantity(2);
            item.setOpts(opts);
            eng.addToBasket(sessionId, 0, item);
        }

        BasketIf item1 = new Basket();

        item1.setProductId(PROD_ID);
        item1.setQuantity(1);

        eng.addToBasket(sessionId, 0, item1);

        BasketIf[] items = eng.getBasketItemsPerCustomer(sessionId, 0, DEFAULT_LANGUAGE);
        System.out.println("items.................................." + items);

        OrderIf order = eng.createOrder(sessionId, items, DEFAULT_LANGUAGE);
        System.out.println("order1.................................." + order);

        ShippingQuoteIf[] sQuotes = eng.getShippingQuotes(order, DEFAULT_LANGUAGE);
        System.out.println("sQuotes................................" + sQuotes);
        if (sQuotes != null && sQuotes.length > 0)
        {
            order.setShippingQuote(sQuotes[0]);
        }

        PaymentDetailsIf[] pGateways = eng.getPaymentGateways(order, DEFAULT_LANGUAGE);
        System.out.println("pGateways..............................." + pGateways);
        if (pGateways != null && pGateways.length > 0)
        {
            order.setPaymentDetails(pGateways[0]);
        }


        order = eng.getOrderTotals(order, DEFAULT_LANGUAGE);
//        OrderTotalIf[] orderTotals = 
        order.setPaymentMethod("alipay");
        System.out.println("order2..................................." + order);
        System.out.println("paymentDetails......................" + order.getPaymentDetails());
        System.out.println("paymentMethod......................." + order.getPaymentMethod());

        order.setStatus(PENDING);

        OrderStatusHistoryIf status = new OrderStatusHistory();
        status.setOrderStatusId(PENDING);
        status.setComments("Waiting for Payment");

        OrderStatusHistoryIf[] statusArray = new OrderStatusHistoryIf[]
                { status };
        order.setStatusTrail(statusArray);

        order.setCustom1("custom1");
        order.setCustom5("custom5");

        int orderId = eng.saveOrder(sessionId, order, DEFAULT_LANGUAGE);
        System.out.println("orderId............................." + orderId);

        eng.changeOrderStatus(sessionId, orderId, PROCESSING, /* Notify customer */false,
                "We've got the dosh, now let's ship it");


        eng.updateInventory(sessionId, orderId);


        order = eng.getOrder(sessionId, orderId, DEFAULT_LANGUAGE);
        System.out.println(order.toString());

        return SUCCESS;
        }catch(Exception e){
            e.printStackTrace();
            return INPUT;
        }
    }
}

